## regina-normal 7.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 3.12)
PROJECT (regina)

# Let the user override the package name.
IF(NOT PACKAGE_NAME)
  SET (PACKAGE_NAME regina CACHE STRING
    "The package name used for installation directories.  On some platforms this is 'regina-normal', not 'regina', to avoid conflicts with other software with the same name."
    FORCE)
ENDIF(NOT PACKAGE_NAME)

SET (PACKAGE_PRETTY_NAME Regina)
# Look here for Find___.cmake modules
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

# Version
SET (PACKAGE_VERSION 7.0)
SET (SNAPPY_VERSION 2.8)
SET (PACKAGE_STRING "${PACKAGE_PRETTY_NAME} ${PACKAGE_VERSION}")

# Extract major/minor version
# Note: The PACKAGE_VERSION_MAJOR "output" is discarded, since it matches the
# whole string
STRING(REGEX MATCH "^([0-9]+).([0-9]+)" PACKAGE_VERSION_MAJOR "${PACKAGE_VERSION}")
SET (PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1} )
SET (PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2} )

# Make a release build by default.
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build.  Options are: Debug Release RelWithDebInfo MinSizeRel."
  FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(HIGHDIM "OFF" CACHE BOOL INTERNAL)
IF(HIGHDIM)
  MESSAGE (STATUS "Dimensions 9-15: enabled")
  SET (REGINA_HIGHDIM TRUE)
ELSE(HIGHDIM)
  MESSAGE (STATUS "Dimensions 9-15: disabled for performance - to enable these, pass -DHIGHDIM=1")
  SET (REGINA_HIGHDIM FALSE)
ENDIF(HIGHDIM)

# Every year I swear I will drop windows support, and this year is no different.
# The windows build (as of November 2015) crashes in the test suite with -O3.
# It looks as though this might be a compiler problem: the ipa-cp-clone
# optimisation has been known to cause crashes under mingw in other projects
# in the past also.
IF (WIN32)
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-ipa-cp-clone")
ENDIF (WIN32)

# Regina's own cmake scripts:
INCLUDE( ReginaMacros )

# Distinguish between the different Regina installation types:
# XDG = standard freedesktop.org filesystem installation in a fixed location.
# HPC = filesystem installation suitable for HPC systems where there is
#       no need for a GUI or HTML documentation, and where you do not have root.
# Windows = self-contained movable install directory for MS Windows.
if (NOT REGINA_INSTALL_TYPE)
  if (WIN32)
    SET (REGINA_DEFAULT_INSTALL_TYPE Windows)
  else ()
    SET (REGINA_DEFAULT_INSTALL_TYPE XDG)
  endif ()
  SET (REGINA_INSTALL_TYPE ${REGINA_DEFAULT_INSTALL_TYPE} CACHE STRING
    "Choose how Regina installs itself.  Options are: XDG HPC Windows."
    FORCE)
ENDIF (NOT REGINA_INSTALL_TYPE)
MESSAGE (STATUS "Regina install type: ${REGINA_INSTALL_TYPE}")

# Sanity check the installation type, and set the boolean install type flags
# that will appear in regina-config.h.
# Note: even though Bundle is not supported in CMake, we must keep the flag
# here because the Xcode build uses it (via the corresponding #define).
SET(REGINA_INSTALL_XDG FALSE)
SET(REGINA_INSTALL_HPC FALSE)
SET(REGINA_INSTALL_BUNDLE FALSE)
SET(REGINA_INSTALL_WINDOWS FALSE)
IF (${REGINA_INSTALL_TYPE} STREQUAL XDG)
  # No sanity checking needed here (yet).
  SET(REGINA_INSTALL_XDG TRUE)
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL HPC)
  # No sanity checking needed here either.
  SET(REGINA_INSTALL_HPC TRUE)
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL Bundle)
  MESSAGE(FATAL_ERROR
    "REGINA_INSTALL_TYPE=Bundle is no longer supported. These CMake build scripts will give a unix-style installation in a fixed location; for a standalone macOS app bundle please use Xcode instead.")
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL Windows)
  IF (NOT WIN32)
    MESSAGE(FATAL_ERROR
      "REGINA_INSTALL_TYPE=Windows is only supported on MS Windows.")
  ENDIF (NOT WIN32)
  SET(REGINA_INSTALL_WINDOWS TRUE)
ELSE()
  MESSAGE(FATAL_ERROR
    "REGINA_INSTALL_TYPE must be XDG, HPC or Windows.")
ENDIF()

IF(NOT (WIN32 OR APPLE))
  CHECK_LSB_RELEASE()
ENDIF(NOT (WIN32 OR APPLE))

# Are we installing development files?
SET (REGINA_INSTALL_DEV ON)

# Give packagers a way of insisting that every optional component is found.
# Set PACKAGING_MODE=1 to make every component compulsory.
IF(NOT PACKAGING_MODE)
  SET (PACKAGING_MODE OFF CACHE STRING
    "Makes all optional components mandatory, so that cmake will fail if any optional component is not found."
    FORCE)
ENDIF(NOT PACKAGING_MODE)
IF(PACKAGING_MODE)
  SET(REGINA_MANDATORY TRUE)
ELSE(PACKAGING_MODE)
  SET(REGINA_MANDATORY FALSE)
ENDIF(PACKAGING_MODE)

# Options that indicate how python is shipped.
IF(NOT PYTHON_CORE_IN_ZIP)
  SET (PYTHON_CORE_IN_ZIP OFF CACHE STRING
    "Indicates that Regina ships its own Python, with the core Python libraries in pythonXY.zip."
    FORCE)
ENDIF(NOT PYTHON_CORE_IN_ZIP)

# The iOS build of Regina links the python module directly into the GUI,
# and there is a flag in regina-config.h to indicate this.
# Such a configuration is not, however, supported by regina's cmake build
# system, and so we do not allow cmake users to enable it.
SET (PYTHON_STATIC_LINK OFF)

# For pretty logging of optional features at the end of the cmake run:
INCLUDE(MacroLogFeature)

# Modules needed for IOS check and function existence
INCLUDE( CheckCXXSourceCompiles )
INCLUDE( CheckFunctionExists )

# We need to determine threading flags *before* testing for C++11 std::thread.
FIND_PACKAGE(Threads REQUIRED)
IF(NOT Threads_FOUND)
  MESSAGE(FATAL_ERROR "Regina requires threading support.")
ENDIF(NOT Threads_FOUND)
IF(CMAKE_COMPILER_IS_GNUCXX)
  # The FindThreads module picks up -lpthread, not -pthread.
  # This is unfortunate, because std::thread must be built with -pthread
  # under g++; otherwise it builds but throws an exception at runtime.
  SET(CMAKE_CXX_FLAGS "-pthread ${CMAKE_CXX_FLAGS}")
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

# Make everything use C++17 (or later).
SET(CMAKE_CXX_STANDARD 17)
SET(CMAKE_CXX_STANDARD_REQUIRED YES)
SET(CMAKE_CXX_EXTENSIONS OFF)

CHECK_STDFS()
IF (NOT STDFS_FOUND)
  MESSAGE(FATAL_ERROR "Your compiler does not appear to support either the C++17 std::filesystem or the alternative std::experimental::filesystem.")
ENDIF (NOT STDFS_FOUND)

# Always include . in the header search path:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Installation directories
SET (APPDIR "${CMAKE_INSTALL_PREFIX}/bin")
SET (BINDIR "${CMAKE_INSTALL_PREFIX}/bin")
SET (LIBDIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
SET (DATADIR "${CMAKE_INSTALL_PREFIX}/share")
SET (INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/${PACKAGE_NAME}")
SET (PKGDATADIR "${DATADIR}/${PACKAGE_NAME}")
if (${REGINA_INSTALL_TYPE} STREQUAL XDG)
  UNSET (PYLIBDIR)
else ()
  SET (PYLIBDIR "${LIBDIR}/${PACKAGE_NAME}/python")
endif ()
SET (HTMLDIR "${PKGDATADIR}/docs")
SET (ICONDIR "${DATADIR}/icons")
SET (MANDIR "${DATADIR}/man")
SET (XDG_APPS_INSTALL_DIR "${DATADIR}/applications")
SET (XDG_MIME_INSTALL_DIR "${DATADIR}/mime/packages")
SET (XDG_METAINFO_DIR "${DATADIR}/metainfo")

# Useful build directories
SET (ENGINE_INCLUDES "${PROJECT_SOURCE_DIR}/engine" )
SET (ENGINE_LIBRARY regina-engine)

# Paths that we need to escape for @...@ substitution into bash/perl scripts
REGINA_ESCAPE_BASH (CMAKE_SOURCE_DIR)
REGINA_ESCAPE_BASH (CMAKE_INSTALL_PREFIX)
REGINA_ESCAPE_BASH (INCLUDEDIR)
REGINA_ESCAPE_BASH (LIBDIR)
REGINA_ESCAPE_PERL (CMAKE_INSTALL_PREFIX)
REGINA_ESCAPE_PERL (LIBDIR)
REGINA_ESCAPE_PERL (PYLIBDIR)
REGINA_ESCAPE_PERL (PKGDATADIR)

# RPATH support.
IF (NOT DISABLE_RPATH)
  SET(DISABLE_RPATH OFF CACHE BOOL
    "Do not build with rpath.  This option may break installations in non-standard directories, since executables may be unable to find Regina's libraries.  For installations in standard areas such as /usr however, this option is highly recommended." FORCE)
ENDIF (NOT DISABLE_RPATH)

IF (NOT DISABLE_RPATH)
  if (APPLE)
    set(CMAKE_INSTALL_NAME_DIR "${LIBDIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  else (APPLE)
    set(CMAKE_INSTALL_RPATH "${LIBDIR}")
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  endif (APPLE)
ENDIF (NOT DISABLE_RPATH)

# i18n checks.
CHECK_CXX_SOURCE_COMPILES("
  #include \"langinfo.h\"
  int main() { nl_langinfo(CODESET); return 0; }"
  LANGINFO_FOUND )
if(NOT LANGINFO_FOUND)
  MESSAGE(WARNING "langinfo not found: UTF-8 will be used always, and the locale-specific encoding will be ignored.")
endif(NOT LANGINFO_FOUND)

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  int128_t x;
  uint128_t y;
  int main() { return 0; }"
  INTERNAL_INT128_T_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  __int128 x;
  __uint128 y;
  int main() { return 0; }"
  INTERNAL___INT128_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  __int128_t x;
  __uint128_t y;
  int main() { return 0; }"
  INTERNAL___INT128_T_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  unsigned long long x = 0xFFFFFFFFFFFFFFFF;
  int main() { return 0; }"
  NUMERIC_64_FOUND)
CHECK_CXX_SOURCE_COMPILES("
  unsigned long long x = 0xFFFFFFFFFFFFFFFFLL;
  int main() { return 0; }"
  NUMERIC_64_LL_FOUND)

# Dependencies used by all components of Regina

# Note that pkg-config is optional, but it does help us find some libraries
# that we could perhaps not have found otherwise.
# In particular, most build environments will need it to locate Graphviz.
FIND_PACKAGE(PkgConfig)

FIND_PACKAGE(ZLIB)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
MACRO_LOG_FEATURE(ZLIB_FOUND
  "zlib"
  "Essential: compression support"
  "http://www.gzip.org/zlib/"
  TRUE)

FIND_PACKAGE(LibXml2)
INCLUDE_DIRECTORIES(${LIBXML2_INCLUDE_DIR})
MACRO_LOG_FEATURE(LIBXML2_FOUND
  "libxml2"
  "Essential: XML support"
  "ftp.gnome.org"
  TRUE)

FIND_PACKAGE(GMP)
INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR})
MACRO_LOG_FEATURE(GMP_FOUND
  "GMP/C"
  "Essential: large integer arithmetic support for C"
  "http://gmplib.org/"
  TRUE)

FIND_PACKAGE(GMPXX)
INCLUDE_DIRECTORIES(${GMPXX_INCLUDE_DIR})
MACRO_LOG_FEATURE(GMPXX_FOUND
  "GMP/C++"
  "Essential: large integer arithmetic support for C++"
  "http://gmplib.org/"
  TRUE)

FIND_PACKAGE(ICONV)
INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})
MACRO_LOG_FEATURE(ICONV_FOUND
  "iconv"
  "Essential: internationalisation support"
  "http://www.gnu.org/s/libiconv/"
  TRUE)

FIND_PACKAGE(Jansson)
INCLUDE_DIRECTORIES(${JANSSON_INCLUDE_DIR})
MACRO_LOG_FEATURE(JANSSON_FOUND
  "Jansson"
  "Essential: JSON support"
  "http://www.digip.org/jansson/"
  TRUE)

IF (NOT DISABLE_PYTHON)
  MESSAGE (STATUS "Searching for a Python installation")

  # Some basic sanity testing on the user's python settings.
  IF (PYTHON_EXECUTABLE)
    UNSET(PYTHON_EXECUTABLE CACHE)
    MESSAGE(FATAL_ERROR "Regina now uses a different method for finding Python. The old PYTHON_EXECUTABLE setting is no longer recognised. Please set Python_EXECUTABLE instead.")
  ENDIF (PYTHON_EXECUTABLE)
  IF (Python_EXECUTABLE)
    IF(${CMAKE_VERSION} VERSION_LESS "3.16.0")
      UNSET(Python_EXECUTABLE CACHE)
      MESSAGE(FATAL_ERROR "The Python_EXECUTABLE setting only works with CMake 3.16 and above. For now please either upgrade your CMake, or else remove (or temporarily hide) any conflicting Python installations so that the automated tools can find the correct Python without assistance.")
    ENDIF(${CMAKE_VERSION} VERSION_LESS "3.16.0")
  ENDIF (Python_EXECUTABLE)

  FIND_PACKAGE(Python COMPONENTS Interpreter Development REQUIRED)

  IF (Python_FOUND)
    IF (${Python_VERSION_MAJOR} EQUAL 2)
      IF (${Python_VERSION_MINOR} LESS 6)
        MESSAGE(FATAL_ERROR "For Python 2.x, Regina needs Python >= 2.6.")
      ENDIF ()
    ELSEIF (${Python_VERSION_MAJOR} EQUAL 3)
      IF (${Python_VERSION_MINOR} LESS 1)
        MESSAGE(FATAL_ERROR "For Python 3.x, Regina needs Python >= 3.1.")
      ENDIF ()
    ELSE ()
      MESSAGE(FATAL_ERROR "Unknown Python major version: ${Python_VERSION_MAJOR}")
    ENDIF ()
  ENDIF (Python_FOUND)

  # We need to properly escape the python executable for use in the bash
  # script regina-python.

=== engine/CMakeLists.txt ===
# Engine

# Note: Any flags that need to be picked up by internal compiled engine tools
# (such as mkcensusdb) need to appear *before* the list of subdirectories.

# Pick up generated engine headers (e.g., regina-config.h) as well as
# Regina's standard engine headers.
INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/engine")
INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}/engine")

# The key-value store is only used internally by the engine (i.e., it
# never appears in the engine headers, only the .cpp sources).
# Therefore we include it only here within engine/, not globally.
INCLUDE_DIRECTORIES(${KVSTORE_INCLUDE_DIRS})
LINK_DIRECTORIES(${KVSTORE_LIBRARY_DIRS})

SET ( SOURCES )
# Each of these subdirectories modifies the SOURCE variable,
# adding more source files
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("core")
ADD_SUBDIRECTORY("data")
ADD_SUBDIRECTORY("enumerate")
ADD_SUBDIRECTORY("file")
ADD_SUBDIRECTORY("foreign")
ADD_SUBDIRECTORY("hypersurface")
ADD_SUBDIRECTORY("libnormaliz")
ADD_SUBDIRECTORY("link")
ADD_SUBDIRECTORY("manifold")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("packet")
ADD_SUBDIRECTORY("progress")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("split")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surface")
ADD_SUBDIRECTORY("surfaces") # deprecated
ADD_SUBDIRECTORY("syntax")
ADD_SUBDIRECTORY("treewidth")
ADD_SUBDIRECTORY("triangulation")
ADD_SUBDIRECTORY("utilities")

# Some C files need to be compiled using the C++ compiler (e.g., snappea,
# where we have added C++ namespaces).
SET_SOURCE_FILES_PROPERTIES( ${SOURCES_C_AS_CPP} PROPERTIES LANGUAGE CXX )

# Ensure that, when building under Windows, the linker is given the full list
# of symbols to export in the DLL.  This avoids the need to manage attributes
# such as __declspec(dllexport) and __declspec(dllimport) within the C++ code.
SET(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

ADD_LIBRARY("regina-engine" SHARED ${SOURCES} )
# All of the libraries that appear in ENGINE_LINK_LIBRARIES feature in
# the engine headers, which means they may be expose to third-party apps
# that build against libregina-engine.
# Note: PUBLIC and PRIVATE only appeard in CMake 2.8.12.
# For compatibility back to 2.8.7 we use LINK_PUBLIC and LINK_PRIVATE instead.
SET(ENGINE_LINK_LIBRARIES ${LIBXML2_LIBRARIES} ${GMP_LIBRARIES} ${GMPXX_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
TARGET_LINK_LIBRARIES(regina-engine
  LINK_PUBLIC ${ENGINE_LINK_LIBRARIES}
  LINK_PRIVATE ${STDFS_LIBRARY} "${ICONV_LIBRARY}" ${ZLIB_LIBRARIES} ${JANSSON_LIBRARIES} ${KVSTORE_LIBRARIES})
SET_TARGET_PROPERTIES(regina-engine PROPERTIES VERSION ${PACKAGE_VERSION})
SET_TARGET_PROPERTIES(regina-engine PROPERTIES SOVERSION ${PACKAGE_VERSION})

SET( HEADERS ${HEADERS} docs.h regina-core.h )
SET( MANS ${MANS} regina-engine-config.1 )

# Build space-separated lists of flags for regine-engine-config:
GET_DIRECTORY_PROPERTY(ENGINE_INCLUDE_DIRECTORIES DIRECTORY .. INCLUDE_DIRECTORIES)
foreach(arg ${ENGINE_INCLUDE_DIRECTORIES})
  SET(RECONFIG_INCLUDE_FLAGS "${RECONFIG_INCLUDE_FLAGS} -I${arg}")
endforeach(arg ${ENGINE_INCLUDE_DIRECTORIES})
foreach(arg ${ENGINE_LINK_LIBRARIES})
  SET(RECONFIG_LINK_FLAGS "${RECONFIG_LINK_FLAGS} ${arg}")
endforeach(arg ${ENGINE_LINK_LIBRARIES})
REGINA_ESCAPE_BASH (RECONFIG_INCLUDE_FLAGS)
REGINA_ESCAPE_BASH (RECONFIG_LINK_FLAGS)
CONFIGURE_FILE (
  regina-engine-config.in
  "${PROJECT_BINARY_DIR}/engine/regina-engine-config"
  @ONLY
)

INSTALL(TARGETS regina-engine
  LIBRARY DESTINATION "${LIBDIR}"
  RUNTIME DESTINATION "${BINDIR}"
  COMPONENT Runtime)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES ${HEADERS} DESTINATION "${INCLUDEDIR}" COMPONENT Development)
  INSTALL(FILES "${CMAKE_BINARY_DIR}/engine/regina-config.h" DESTINATION "${INCLUDEDIR}" COMPONENT Development)
  INSTALL(PROGRAMS "${PROJECT_BINARY_DIR}/engine/regina-engine-config" DESTINATION bin COMPONENT Development)
  INSTALL(FILES regina-engine-config.1 DESTINATION "${MANDIR}/man1" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

# Miscellaneous extras:
ADD_SUBDIRECTORY("doxygen")

=== examples/CMakeLists.txt ===

SET(examplesdir "${PKGDATADIR}/examples")

SET(examples_files
  README.txt
  closed-hyp-census.rga
  closed-or-census.rga
  closed-nor-census.rga
  cusped-hyp-or-census.rga
  cusped-hyp-nor-census.rga
  knot-census.rga
  progress.session
  tree.session
  triangulation.session
  )
INSTALL(FILES ${examples_files} DESTINATION "${examplesdir}")

# Files that come with different versions for python 2 vs python 3:

SET(py23_files
  sample-pyX.rga
  progress-pyX.py
  tree-pyX.py
  triangulation-pyX.py
  )

IF (Python_FOUND)
  IF ("${Python_VERSION_MAJOR}" EQUAL 3)
    SET (PYX py3)
  ELSEIF ("${Python_VERSION_MAJOR}" EQUAL 2)
    SET (PYX py2)
  ELSE ()
    MESSAGE(FATAL_ERROR "Unknown Python version: ${Python_VERSION_MAJOR}")
  ENDIF ()
ELSE (Python_FOUND)
  # Just choose one.
  SET (PYX py3)
ENDIF (Python_FOUND)

FOREACH (FILE ${py23_files})
  STRING (REPLACE "-pyX" "-${PYX}" _SRC "${FILE}")
  STRING (REPLACE "-pyX" "" _DEST "${FILE}")
  INSTALL(FILES ${_SRC} DESTINATION "${examplesdir}" RENAME ${_DEST})
ENDFOREACH (FILE ${py23_files})

=== python/CMakeLists.txt ===
SET ( SOURCES globalarray.cpp modulemain.cpp )
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("dim2")
ADD_SUBDIRECTORY("dim3")
ADD_SUBDIRECTORY("dim4")
ADD_SUBDIRECTORY("enumerate")
ADD_SUBDIRECTORY("file")
ADD_SUBDIRECTORY("foreign")
ADD_SUBDIRECTORY("generic")
ADD_SUBDIRECTORY("hypersurface")
ADD_SUBDIRECTORY("link")
ADD_SUBDIRECTORY("manifold")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("packet")
ADD_SUBDIRECTORY("progress")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("split")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surface")
ADD_SUBDIRECTORY("treewidth")
ADD_SUBDIRECTORY("utilities")

ADD_SUBDIRECTORY("testsuite")
ADD_SUBDIRECTORY("sage")

# The module itself is built in the regina/ subdirectory, so that we can
# import the module directly from the source tree if we like.
ADD_SUBDIRECTORY("regina")

# The startup script for users:
CONFIGURE_FILE (
  "${PROJECT_SOURCE_DIR}/python/regina-python.in"
  "${PROJECT_BINARY_DIR}/python/regina-python"
  @ONLY
)

INSTALL(PROGRAMS "${PROJECT_BINARY_DIR}/python/regina-python" DESTINATION "${BINDIR}" COMPONENT Runtime)

=== testsuite/CMakeLists.txt ===
SET ( SOURCES
  exhaustive.cpp
  runalltests.cpp
  testsuite.cpp
  )
# Each of these subdirectories modifies the SOURCES variable,
# adding more source files
ADD_SUBDIRECTORY("compile-time")

ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("dim2")
ADD_SUBDIRECTORY("dim3")
ADD_SUBDIRECTORY("dim4")
ADD_SUBDIRECTORY("generic")
ADD_SUBDIRECTORY("link")
ADD_SUBDIRECTORY("manifold")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("misc")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surface")
ADD_SUBDIRECTORY("utilities")

INCLUDE_DIRECTORIES(${ENGINE_INCLUDES})
INCLUDE_DIRECTORIES(${CPPUNIT_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/engine)
ADD_EXECUTABLE(regtestsuite ${SOURCES})
TARGET_LINK_LIBRARIES(regtestsuite ${ENGINE_LIBRARY} ${CPPUNIT_LIBRARY}) # TODO

ADD_TEST(cpp-test regtestsuite)
IF (WIN32)
  # On Windows we need to add the engine DLL location to the runtime path.
  # The string replacement is to prevent cmake treating $ENV{PATH} as a list.
  string(REPLACE ";" "\\;" ESCAPED_PATH "$ENV{PATH}")
  SET_PROPERTY(TEST cpp-test PROPERTY ENVIRONMENT
    "PATH=${ESCAPED_PATH}\;${PROJECT_BINARY_DIR}/engine")
ENDIF (WIN32)

=== docs/engine/CMakeLists.txt ===

# TODO: The doxygen files generated in the build tree are not removed
# by "make clean".

if (REGINA_ENGINE_DOCS)
  ADD_CUSTOM_COMMAND(OUTPUT index.html VERBATIM
    COMMAND "${UNZIP_EXECUTABLE}" -o -j -d "${CMAKE_CURRENT_BINARY_DIR}"
      "${REGINA_ENGINE_DOCS_FILE}")
else (REGINA_ENGINE_DOCS)
  FILE(GLOB _png ../../engine/*/*.png)
  FILE(COPY ${_png} DESTINATION .)
  ADD_CUSTOM_COMMAND(OUTPUT index.html VERBATIM
    COMMAND "${DOXYGEN_EXECUTABLE}" "${PROJECT_BINARY_DIR}/engine/doxygen/docs.conf"
    )
endif (REGINA_ENGINE_DOCS)

ADD_CUSTOM_TARGET(docs ALL DEPENDS index.html)

INSTALL(
  DIRECTORY "${PROJECT_BINARY_DIR}/docs/engine/"
  DESTINATION "${PKGDATADIR}/engine-docs"
  FILES_MATCHING
  PATTERN CMakeFiles EXCLUDE
  PATTERN "*.css"
  PATTERN "*.dot"
  PATTERN "*.gif"
  PATTERN "*.html"
  PATTERN "*.jpg"
  PATTERN "*.js"
  PATTERN "*.png"
  PATTERN "*.txt"
  )

=== engine/algebra/CMakeLists.txt ===
# algebra

# Files to compile
SET ( FILES
  abeliangroup.cpp
  covers.cpp
  grouppresentation.cpp
  homgrouppresentation.cpp
  markedabeliangroup.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} algebra/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    abeliangroup.h
    grouppresentation.h
    homgrouppresentation.h
    markedabeliangroup.h
    DESTINATION "${INCLUDEDIR}/algebra" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/core/CMakeLists.txt ===
# Files to compile
SET ( FILES engine.cpp )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} core/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    engine.h
    output.h
    DESTINATION "${INCLUDEDIR}/core" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/enumerate/CMakeLists.txt ===
# enumerate

# Files to compile
SET ( FILES
  treeconstraint.cpp
  treelp.cpp
  treetraversal.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} enumerate/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    doubledescription.h
    doubledescription-impl.h
    hilbertcd.h
    hilbertcd-impl.h
    hilbertdual.h
    hilbertdual-impl.h
    hilbertprimal.h
    hilbertprimal-impl.h
    maxadmissible.h
    maxadmissible-impl.h
    ordering.h
    treeconstraint.h
    treeconstraint-impl.h
    treelp.h
    treelp-impl.h
    treetraversal.h
    treetraversal-impl.h
    typetrie.h
    validityconstraints.h
    DESTINATION "${INCLUDEDIR}/enumerate" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/foreign/CMakeLists.txt ===
# foreign

# Files to compile
SET ( FILES
  dehydration.cpp
  isosig.cpp
  orb.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} foreign/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    dehydration.h
    fromsiglist-impl.h
    isosig.h
    orb.h
    DESTINATION "${INCLUDEDIR}/foreign" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/libnormaliz/CMakeLists.txt ===
# normaliz

# Files to compile.
#
# Currently we exclude: nmz_integral, nmz_nauty
SET ( FILES
  HilbertSeries.cpp
  automorph.cpp
  collection.cpp
  cone.cpp
  cone_dual_mode.cpp
  cone_property.cpp
  descent.cpp
  face_lattice.cpp
  full_cone.cpp
  general.cpp
  input.cpp
  matrix.cpp
  offload_handler.cpp
  options.cpp
  output.cpp
  project_and_lift.cpp
  reduction.cpp
  simplex.cpp
  sublattice_representation.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} libnormaliz/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

# Set the variable in the parent directory
SET(SOURCES ${SOURCES} PARENT_SCOPE)

# Normaliz headers should not be shipped: these are for internal use only.

=== engine/maths/CMakeLists.txt ===
# maths 

ADD_SUBDIRECTORY("spec")

# Files to compile
SET ( FILES
  cyclotomic.cpp
  integer.cpp
  matrix2.cpp
  matrixops.cpp
  numbertheory.cpp
  primes.cpp
  rational.cpp
  seedprimes.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} maths/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL( FILES
    binom.h
    cyclotomic.h
    integer.h
    laurent.h
    laurent2.h
    matrix.h
    matrix2.h
    matrixops.h
    numbertheory.h
    perm.h
    perm-impl.h
    polynomial.h
    primes.h
    rational.h
    ray.h
    vector.h
    DESTINATION "${INCLUDEDIR}/maths" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== debian/changelog ===
regina-normal (7.0-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 14 Jan 2022 11:38:55 +0000

regina-normal (7.0-2) unstable; urgency=low

  * Fixed the command-line utilities test suite on s390.
  * Build-depends on bsdextrautils (which provides hexdump), and also made
    the autopkgtests depend on this for the same reason.

 -- Ben Burton <bab@debian.org>  Mon, 20 Dec 2021 00:02:08 +1000

regina-normal (7.0-1) unstable; urgency=low

  * New upstream release.
  * Removed build-depends on libboost-dev, since upstream no longer requires it.
  * Build-depends on cmake (>= 3.12) and doxygen (>= 1.8.17), following the
    new requirements from upstream.
  * Changed the python build-depends from python3-all-dev to python3-dev
    (closes: #998455).
  * Downgraded gap from recommends to suggests.

 -- Ben Burton <bab@debian.org>  Fri, 17 Dec 2021 23:02:54 +1000

=== debian/control ===
Source: regina-normal
Section: math
Priority: optional
Maintainer: Ben Burton <bab@debian.org>
Homepage: http://regina-normal.github.io/
Build-Depends:
    bsdextrautils,
    debhelper (>= 11),
    dh-python,
    cmake (>= 3.12),
    doxygen (>= 1.8.17),
    libcppunit-dev (>= 1.10.2-4),
    libgmp-dev (>= 4.1.4-10),
    libgraphviz-dev,
    libjansson-dev,
    libpopt-dev,
    libqt5svg5-dev,
    libtokyocabinet-dev,
    libxml2-dev,
    pkg-config,
    python3-dev,
    qtbase5-dev,
    shared-mime-info,
    xsltproc,
    zlib1g-dev,
    dpkg-dev (>= 1.16.0)
Standards-Version: 4.5.1

Package: regina-normal
Architecture: any
Section: math
Pre-Depends: ${misc:Pre-Depends}
Depends:
    ${shlibs:Depends},
    ${perl:Depends},
    ${python3:Depends},
    ${misc:Depends}
Recommends: regina-normal-doc (>= 7.0-0), evince | pdf-viewer
Suggests: regina-normal-dev, gap
Description: mathematical software for low-dimensional topology
 Regina is a software package for 3-manifold and 4-manifold topologists,
 with a focus on triangulations, knots and links, normal surfaces, and
 angle structures.
 .
 For 3-manifolds, it includes high-level tasks such as 3-sphere recognition,
 connected sum decomposition and Hakenness testing, comes with a rich
 database of census manifolds, and incorporates the SnapPea kernel for
 working with hyperbolic manifolds.  For 4-manifolds, it offers a range of
 combinatorial and algebraic tools, plus support for normal hypersurfaces.
 For knots and links, Regina can perform combinatorial manipulation,
 compute knot polynomials, and work with several import/export formats.
 .
 Regina comes with a full graphical user interface, as well as Python bindings
 and a low-level C++ programming interface.
 .
 This package includes the graphical user interface and the command-line
 Python interface.  The users' handbook and the API documentation are in
 the separate package regina-normal-doc.

Package: regina-normal-dev
Architecture: any
Section: libdevel
Depends:
    regina-normal (= ${binary:Version}),
    libgmp-dev,
    libxml2-dev,
    zlib1g-dev,
    ${misc:Depends}
Suggests: regina-normal-doc
Description: development files for Regina, the topology software
 Regina is a software package for low-dimensional topologists.  This package
 provides development files for compiling Regina's mathematical engine into
 other projects.
 .
 The calculation engine is provided as a C++ shared library.  For complete
 API documentation, see the package regina-normal-doc.
 .
 Regina focuses on the study of 3-manifold and 4-manifold triangulations,
 knots and links, normal surfaces, and angle structures.  For Regina's
 standard graphical user interface, and for more information about what
 Regina can do, see the package regina-normal.

Package: regina-normal-doc
Architecture: all
Section: doc
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Recommends: iceweasel | www-browser
Suggests: regina-normal, regina-normal-dev
Breaks: regina-normal (<< 4.6-2)
Replaces: regina-normal (<< 4.6-2)
Description: documentation for Regina, the topology software
 Regina is a software package for low-dimensional topologists.  This package
 provides a rich users' handbook, complete API documentation for the C++
 calculation engine and Python bindings, and the full specification for
 Regina's XML data file format.
 .
 Regina focuses on the study of 3-manifold and 4-manifold triangulations,
 knots and links, normal surfaces, and angle structures.  For Regina's
 standard graphical user interface, and for more information about what
 Regina can do, see the package regina-normal.

=== debian/tests/control ===
Test-Command: debian/tests/utils-test censuslookup
Features: test-name=utils-censuslookup
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regconcat
Features: test-name=utils-regconcat
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regconvert
Features: test-name=utils-regconvert
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regfiledump
Features: test-name=utils-regfiledump
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regfiletype
Features: test-name=utils-regfiletype
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test retriangulate
Features: test-name=utils-retriangulate
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test sigcensus
Features: test-name=utils-sigcensus
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test tricensus
Features: test-name=utils-tricensus
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test trisetcmp
Features: test-name=utils-trisetcmp
Depends: @, bsdextrautils

Test-Command: debian/tests/python-test alltypes
Features: test-name=python-alltypes

Test-Command: debian/tests/python-test angles
Features: test-name=python-angles

Test-Command: debian/tests/python-test bytes
Features: test-name=python-bytes

Test-Command: debian/tests/python-test callbacks
Features: test-name=python-callbacks

Test-Command: debian/tests/python-test census
Features: test-name=python-census

Test-Command: debian/tests/python-test clone
Features: test-name=python-clone

Test-Command: debian/tests/python-test constructors
Features: test-name=python-constructors

Test-Command: debian/tests/python-test deprecated
Features: test-name=python-deprecated

Test-Command: debian/tests/python-test discs
Features: test-name=python-discs

Test-Command: debian/tests/python-test embeddings
Features: test-name=python-embeddings

Test-Command: debian/tests/python-test enumerate
Features: test-name=python-enumerate

Test-Command: debian/tests/python-test equality
Features: test-name=python-equality

Test-Command: debian/tests/python-test euler
Features: test-name=python-euler

Test-Command: debian/tests/python-test exception
Features: test-name=python-exception

Test-Command: debian/tests/python-test facenumbering
Features: test-name=python-facenumbering

Test-Command: debian/tests/python-test faces
Features: test-name=python-faces

Test-Command: debian/tests/python-test file python/testsuite
Features: test-name=python-file

Test-Command: debian/tests/python-test generic
Features: test-name=python-generic

Test-Command: debian/tests/python-test groups
Features: test-name=python-groups

Test-Command: debian/tests/python-test hypersurfaces
Features: test-name=python-hypersurfaces

Test-Command: debian/tests/python-test i18n python/testsuite
Features: test-name=python-i18n

Test-Command: debian/tests/python-test id
Features: test-name=python-id

Test-Command: debian/tests/python-test index
Features: test-name=python-index

=== debian/watch ===
version=4
https://github.com/regina-normal/regina/releases .*/regina-(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## regina-normal 7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")
 
 # Version
-SET (PACKAGE_VERSION 7.0)
+SET (PACKAGE_VERSION 7.1)
 SET (SNAPPY_VERSION 2.8)
 SET (PACKAGE_STRING "${PACKAGE_PRETTY_NAME} ${PACKAGE_VERSION}")
 
@@ -300,8 +300,8 @@
   TRUE)
 
 FIND_PACKAGE(Jansson)
-INCLUDE_DIRECTORIES(${JANSSON_INCLUDE_DIR})
-MACRO_LOG_FEATURE(JANSSON_FOUND
+INCLUDE_DIRECTORIES(${Jansson_INCLUDE_DIR})
+MACRO_LOG_FEATURE(Jansson_FOUND
   "Jansson"
   "Essential: JSON support"
   "http://www.digip.org/jansson/"
@@ -322,21 +322,19 @@
     ENDIF(${CMAKE_VERSION} VERSION_LESS "3.16.0")
   ENDIF (Python_EXECUTABLE)
 
+  # Note: FindPython prioritises Python 3 (which is what we want also).
   FIND_PACKAGE(Python COMPONENTS Interpreter Development REQUIRED)
 
   IF (Python_FOUND)
     IF (${Python_VERSION_MAJOR} EQUAL 2)
-      IF (${Python_VERSION_MINOR} LESS 6)
-        MESSAGE(FATAL_ERROR "For Python 2.x, Regina needs Python >= 2.6.")
-      ENDIF ()
+      MESSAGE(FATAL_ERROR "Regina no longer supports Python 2.")
     ELSEIF (${Python_VERSION_MAJOR} EQUAL 3)
-      IF (${Python_VERSION_MINOR} LESS 1)
-        MESSAGE(FATAL_ERROR "For Python 3.x, Regina needs Python >= 3.1.")
+      IF (${Python_VERSION_MINOR} LESS 4)
+        MESSAGE(FATAL_ERROR "Regina needs Python >= 3.4.")
       ENDIF ()
     ELSE ()
       MESSAGE(FATAL_ERROR "Unknown Python major version: ${Python_VERSION_MAJOR}")
     ENDIF ()
   ENDIF (Python_FOUND)
 
-  # We need to properly escape the python executable for use in the bash
-  # script regina-python.
+  # We need to properly escape some python locations for use in various scripts.

=== engine/utilities/CMakeLists.txt ===
# utilities

# Files to compile
SET ( FILES
  boolset.cpp
  base64.cpp
  i18nutils.cpp
  memstream.cpp
  osutils.cpp
  randutils.cpp
  stringutils.cpp
  tightencoding.cpp
  trieset.cpp
  xmlutils.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} utilities/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

# Set the variable in the parent directory
SET( SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    base64.h
    bitmanip.h
    bitmask.h
    boolset.h
    exception.h
    flags.h
    i18nutils.h
    intutils.h
    listview.h
    markedvector.h
    memstream.h
    osutils.h
    qitmask.h
    randutils.h
    sequence.h
    shortarray.h
    sigutils.h
    snapshot.h
    stringutils.h
    stringutils-impl.h
    tightencoding.h
    tightencoding-impl.h
    trieset.h
    typeutils.h
    xmlutils.h
    DESTINATION "${INCLUDEDIR}/utilities" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== python/generic/CMakeLists.txt ===
# Files to compile
SET ( FILES
  cut.cpp
  example5.cpp
  example6.cpp
  example7.cpp
  example8.cpp
  face5.cpp
  face6.cpp
  face7.cpp
  face8.cpp
  facehelper.cpp
  facetpairing2.cpp
  facetpairing4.cpp
  facetpairing5.cpp
  facetpairing6.cpp
  facetpairing7.cpp
  facetpairing8.cpp
  facetspec.cpp
  isomorphism5.cpp
  isomorphism6.cpp
  isomorphism7.cpp
  isomorphism8.cpp
  pygeneric.cpp
  triangulation5.cpp
  triangulation6.cpp
  triangulation7.cpp
  triangulation8.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} generic/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

# These files are only included if HIGHDIM is set
SET ( FILES
  example9.cpp
  example10.cpp
  example11.cpp
  example12.cpp
  example13.cpp
  example14.cpp
  example15.cpp
  face9.cpp
  face10.cpp
  face11.cpp
  face12.cpp
  face13.cpp
  face14.cpp
  face15.cpp
  facetpairing9.cpp
  facetpairing10.cpp
  facetpairing11.cpp
  facetpairing12.cpp
  facetpairing13.cpp
  facetpairing14.cpp
  facetpairing15.cpp
  isomorphism9.cpp
  isomorphism10.cpp
  isomorphism11.cpp
  isomorphism12.cpp
  isomorphism13.cpp
  isomorphism14.cpp
  isomorphism15.cpp
  triangulation9.cpp
  triangulation10.cpp
  triangulation11.cpp
  triangulation12.cpp
  triangulation13.cpp
  triangulation14.cpp
  triangulation15.cpp
  )

IF(HIGHDIM)
  # Prepend folder name
  FOREACH ( SOURCE_FILE ${FILES} )
    SET ( SOURCES ${SOURCES} generic/${SOURCE_FILE})
  ENDFOREACH(SOURCE_FILE)
ENDIF(HIGHDIM)

# Set the variable in the parent directory
SET( SOURCES ${SOURCES} PARENT_SCOPE)

=== python/testsuite/CMakeLists.txt ===

CONFIGURE_FILE(
  testall.in
  "${PROJECT_BINARY_DIR}/python/testsuite/testall"
  @ONLY
)
CONFIGURE_FILE(
  testbasic.in
  "${PROJECT_BINARY_DIR}/python/testsuite/testbasic"
  @ONLY
)

# A very basic interpreter to use for testing:
INCLUDE_DIRECTORIES(${Python_INCLUDE_DIRS} ${ENGINE_INCLUDES} "${PROJECT_BINARY_DIR}/engine")
ADD_LINK_OPTIONS(${Python_LINK_OPTIONS})
add_executable(basic
  basic.cpp
  ../gui/pythoninterpreter.cpp
  ../gui/pythonoutputstream.cpp)
target_link_libraries(basic ${ENGINE_LIBRARY} ${Python_LIBRARIES})

IF (WIN32)
  ADD_TEST(python-test bash testall)
  ADD_TEST(python-basic bash testbasic)
  # We do not need to add the engine DLL location to the path, since
  # regina-python (used in testall) and testbasic (directly) do this for us.
ELSE (WIN32)
  ADD_TEST(python-test ./testall)
  ADD_TEST(python-basic ./testbasic)
ENDIF (WIN32)

=== debian/changelog ===
regina-normal (7.1-1) unstable; urgency=low

  * New upstream release.
  * Now builds against Qt6, not Qt5.
  * Bumped standards-version to 4.6.1 (no changes required).

 -- Ben Burton <bab@debian.org>  Wed, 28 Sep 2022 10:04:35 +1000

=== debian/control ===
--- 
+++ 
@@ -14,17 +14,17 @@
     libgraphviz-dev,
     libjansson-dev,
     libpopt-dev,
-    libqt5svg5-dev,
+    libqt6svg6-dev,
     libtokyocabinet-dev,
     libxml2-dev,
     pkg-config,
     python3-dev,
-    qtbase5-dev,
+    qt6-base-dev,
     shared-mime-info,
     xsltproc,
     zlib1g-dev,
     dpkg-dev (>= 1.16.0)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 
 Package: regina-normal
 Architecture: any
@@ -35,7 +35,7 @@
     ${perl:Depends},
     ${python3:Depends},
     ${misc:Depends}
-Recommends: regina-normal-doc (>= 7.0-0), evince | pdf-viewer
+Recommends: regina-normal-doc (>= 7.1-0), evince | pdf-viewer
 Suggests: regina-normal-dev, gap
 Description: mathematical software for low-dimensional topology
  Regina is a software package for 3-manifold and 4-manifold topologists,

=== debian/tests/control ===
--- 
+++ 
@@ -40,6 +40,9 @@
 Test-Command: debian/tests/python-test angles
 Features: test-name=python-angles
 
+Test-Command: debian/tests/python-test bool
+Features: test-name=python-bool
+
 Test-Command: debian/tests/python-test bytes
 Features: test-name=python-bytes
 
@@ -54,9 +57,6 @@
 
 Test-Command: debian/tests/python-test constructors
 Features: test-name=python-constructors
-
-Test-Command: debian/tests/python-test deprecated
-Features: test-name=python-deprecated
 
 Test-Command: debian/tests/python-test discs
 Features: test-name=python-discs

## regina-normal 7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,8 +12,11 @@
 # Look here for Find___.cmake modules
 SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")
 
+# Regina's own cmake scripts:
+INCLUDE( ReginaMacros )
+
 # Version
-SET (PACKAGE_VERSION 7.1)
+SET (PACKAGE_VERSION 7.2)
 SET (SNAPPY_VERSION 2.8)
 SET (PACKAGE_STRING "${PACKAGE_PRETTY_NAME} ${PACKAGE_VERSION}")
 
@@ -23,6 +26,18 @@
 STRING(REGEX MATCH "^([0-9]+).([0-9]+)" PACKAGE_VERSION_MAJOR "${PACKAGE_VERSION}")
 SET (PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1} )
 SET (PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2} )
+
+IF(BUILD_INFO)
+  SET (PACKAGE_BUILD_STRING "${PACKAGE_STRING} (${BUILD_INFO})")
+ELSE(BUILD_INFO)
+  SET (BUILD_INFO "" CACHE STRING
+    "Optional additional information about this specific build.  Examples might be: \"Official macOS build\", or \"Debian package build\"."
+  FORCE)
+  SET (PACKAGE_BUILD_STRING "${PACKAGE_STRING}")
+ENDIF(BUILD_INFO)
+REGINA_ESCAPE_C (BUILD_INFO)
+REGINA_ESCAPE_C (PACKAGE_BUILD_STRING)
+MESSAGE (STATUS "Detailed version: ${PACKAGE_BUILD_STRING}")
 
 # Make a release build by default.
 IF(NOT CMAKE_BUILD_TYPE)
@@ -48,9 +63,6 @@
 IF (WIN32)
   SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-ipa-cp-clone")
 ENDIF (WIN32)
-
-# Regina's own cmake scripts:
-INCLUDE( ReginaMacros )
 
 # Distinguish between the different Regina installation types:
 # XDG = standard freedesktop.org filesystem installation in a fixed location.
@@ -190,6 +202,7 @@
 REGINA_ESCAPE_BASH (CMAKE_INSTALL_PREFIX)
 REGINA_ESCAPE_BASH (INCLUDEDIR)
 REGINA_ESCAPE_BASH (LIBDIR)
+REGINA_ESCAPE_BASH (PACKAGE_BUILD_STRING)
 REGINA_ESCAPE_PERL (CMAKE_INSTALL_PREFIX)
 REGINA_ESCAPE_PERL (LIBDIR)
 REGINA_ESCAPE_PERL (PYLIBDIR)
@@ -325,16 +338,3 @@
   # Note: FindPython prioritises Python 3 (which is what we want also).
   FIND_PACKAGE(Python COMPONENTS Interpreter Development REQUIRED)
 
-  IF (Python_FOUND)
-    IF (${Python_VERSION_MAJOR} EQUAL 2)
-      MESSAGE(FATAL_ERROR "Regina no longer supports Python 2.")
-    ELSEIF (${Python_VERSION_MAJOR} EQUAL 3)
-      IF (${Python_VERSION_MINOR} LESS 4)
-        MESSAGE(FATAL_ERROR "Regina needs Python >= 3.4.")
-      ENDIF ()
-    ELSE ()
-      MESSAGE(FATAL_ERROR "Unknown Python major version: ${Python_VERSION_MAJOR}")
-    ENDIF ()
-  ENDIF (Python_FOUND)
-
-  # We need to properly escape some python locations for use in various scripts.

=== engine/maths/CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,6 @@
     polynomial.h
     primes.h
     rational.h
-    ray.h
     vector.h
     DESTINATION "${INCLUDEDIR}/maths" COMPONENT Development)
 endif (${REGINA_INSTALL_DEV})

=== python/maths/CMakeLists.txt ===
# maths 

# Files to compile
SET ( FILES
  binom.cpp
  laurent.cpp
  laurent2.cpp
  matrixops.cpp
  cyclotomic.cpp
  integer.cpp
  matrix2.cpp
  matrix.cpp
  numbertheory.cpp
  perm.cpp
  perm2.cpp
  perm3.cpp
  perm4.cpp
  perm5.cpp
  perm6.cpp
  perm7.cpp
  polynomial.cpp
  primes.cpp
  pymaths.cpp
  rational.cpp
  vector.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} maths/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

=== debian/changelog ===
regina-normal (7.2-3) unstable; urgency=low

  * Now builds and runs the test suite correctly under Python 3.11
    (closes: #1027943).

 -- Ben Burton <bab@debian.org>  Tue, 17 Jan 2023 00:02:27 +1000

regina-normal (7.2-2) unstable; urgency=low

  * Fix compile error on powerpc due to use of __bool, which is reserved
    on that platform.
  * Add additional autopkgtests for the new python tests in Regina 7.2.

 -- Ben Burton <bab@debian.org>  Fri, 28 Oct 2022 15:27:28 +1000

regina-normal (7.2-1) unstable; urgency=low

  * New upstream release.

 -- Ben Burton <bab@debian.org>  Thu, 27 Oct 2022 08:17:22 +1000

=== debian/control ===
--- 
+++ 
@@ -35,7 +35,7 @@
     ${perl:Depends},
     ${python3:Depends},
     ${misc:Depends}
-Recommends: regina-normal-doc (>= 7.1-0), evince | pdf-viewer
+Recommends: regina-normal-doc (>= 7.2-0), evince | pdf-viewer
 Suggests: regina-normal-dev, gap
 Description: mathematical software for low-dimensional topology
  Regina is a software package for 3-manifold and 4-manifold topologists,
